BuildRequires(pre): velocity14
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Summary:        Web application framework for J2EE
Name:           webwork
Version:        2.1.7
Release:        alt1_2jpp1.7
Epoch:          0
License:        Apache Software License modified
URL:            http://www.opensymphony.com/webwork/
Group:          Development/Java
Source0:        webwork-2.1.7.tar.bz2
Source1:        webwork-LICENSE.txt
Patch0:         webwork-2.1.7-PellMultiPartRequest.patch
Patch1:         webwork-Multipart.patch
Patch2:         webwork-build_xml.patch
Patch3:         webwork-Script.patch
Patch4:         webwork-ChartResultTest.patch

Patch5:         webwork-Configuration.patch
Patch6:         webwork-VelocityManager.patch
Patch7:         webwork-ExecuteAndWaitInterceptor.patch
Patch8:         webwork-FileUploadInterceptor.patch
Patch9:         webwork-ServletConfigInterceptor.patch
Patch10:        webwork-TokenInterceptor.patch
Patch11:        webwork-WebWorkUtil.patch
Patch12:        webwork-ValidationServlet.patch
Patch13:        webwork-FreemarkerManager.patch
Patch14:        webwork-FreemarkerResult.patch
Patch15:        webwork-FreemarkerServlet.patch
Patch16:        webwork-ActionTag.patch
Patch17:        webwork-BeanTag.patch
Patch18:        webwork-JavaScriptValidationHolder.patch
Patch19:        webwork-LazyResultMap.patch
Patch20:        webwork-MigrationConfigurationTest.patch
Patch21:        webwork-ListValidatorsAction.patch
Patch22:        webwork-TestConfigurationProvider.patch
Patch23:        webwork-TokenInterceptorTest.patch

BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-junit >= 0:1.6
BuildRequires: ant-nodeps >= 0:1.6
BuildRequires: junit >= 0:3.8.1
BuildRequires: jsch
BuildRequires: mockobjects
BuildRequires: mockobjects-alt-jdk1.4
BuildRequires: mockobjects-jdk1.4
BuildRequires: mockobjects-jdk1.4-j2ee1.4
#
BuildRequires: bsf
BuildRequires: bsh
BuildRequires: freemarker
BuildRequires: itext
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-digester
BuildRequires: jakarta-commons-fileupload
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-poi
BuildRequires: jakarta-taglibs-standard
BuildRequires: jasperreports >= 0:1.0.0
BuildRequires: javamail
BuildRequires: jcommon
BuildRequires: jfreechart >= 0:0.9.21
BuildRequires: log4j
BuildRequires: ognl
BuildRequires: oscore
BuildRequires: pell-multipart
BuildRequires: rife-continuations
BuildRequires: servletapi4
BuildRequires: velocity14
BuildRequires: xml-commons-apis
BuildRequires: xwork >= 0:1.2.1
Requires: bsf
Requires: bsh
Requires: freemarker
Requires: itext
Requires: jakarta-commons-beanutils
Requires: jakarta-commons-collections
Requires: jakarta-commons-digester
Requires: jakarta-commons-fileupload
Requires: jakarta-commons-lang
Requires: jakarta-commons-logging
Requires: jakarta-poi
Requires: jakarta-taglibs-standard
Requires: jasperreports >= 0:1.0.0
Requires: javamail
Requires: jcommon
Requires: jfreechart >= 0:0.9.21
Requires: log4j
Requires: ognl
Requires: oscore
Requires: pell-multipart
Requires: servletapi4
Requires: velocity14
Requires: xml-commons-apis
Requires: xwork >= 0:1.2.1
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
WebWork is a Java web-application development framework. 
It is built specifically with developer productivity and 
code simplicity in mind. WebWork is built on top of XWork, 
which provides a generic command pattern framework as well 
as an Inversion of Control container. In addition to these 
features, WebWork provides robust support for building 
reusable UI templates, such as form controls, UI themes, 
internationalization, dynamic form parameter mapping to 
JavaBeans, robust client and server side validation, 
and much more. 

%package multipart
Summary:        Multipart support for %{name}
Group:          Development/Java
Requires: pell-multipart

%description multipart
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -c -n %{name}
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
# Remove example with db4o, this lib is non-free, commercial only
rm -rf src/main/webwork/examples/userreg
# Remove cos-multipart implementation, pell-multipart will do it
rm src/java/com/opensymphony/webwork/dispatcher/multipart/CosMultiPartRequest.java
cp src/example/log4j.properties src/test/log4j.properties
# this test fails
rm src/test/com/opensymphony/webwork/interceptor/TokenSessionStoreInterceptorTest.java

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav

%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav
%patch11 -b .sav
%patch12 -b .sav
%patch13 -b .sav
%patch14 -b .sav
%patch15 -b .sav
%patch16 -b .sav
%patch17 -b .sav
%patch18 -b .sav
%patch19 -b .sav
%patch20 -b .sav
%patch21 -b .sav
%patch22 -b .sav
%patch23 -b .sav

%build

# hack used to build ehcache w/velocity 1.4
mkdir -p .m2/repository/velocity/velocity/1.4
ln -s /usr/share/java/velocity-1.4.jar .m2/repository/velocity/velocity/1.4/
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit"
pushd lib/build
ln -sf $(build-classpath jsch) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath mockobjects-j2ee1.4) .
ln -sf $(build-classpath mockobjects-alt) .
ln -sf $(build-classpath mockobjects) .
ln -sf $(build-classpath mockobjects-core) .
ln -sf $(build-classpath servletapi4) .
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd
pushd lib/core
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath javamail/mailapi) mail.jar
ln -sf $(build-classpath ognl) .
ln -sf $(build-classpath oscore) .
ln -sf $(build-classpath pell-multipart) .
ln -sf $(build-classpath velocity-1.4) .
###BUILD/webwork/lib/core/velocity-dep.jar.no
ln -sf $(build-classpath xwork) .
popd
pushd lib/example
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-lang) .
#BUILD/webwork/lib/example/displaytag.jar.no
#BUILD/webwork/lib/example/jstl.jar.no
ln -sf $(build-classpath taglibs-core) jstl.jar
ln -sf $(build-classpath taglibs-standard) standard.jar
#BUILD/webwork/lib/example/taglibs-benchmark.jar.no
popd
pushd lib/migration
ln -sf $(build-classpath bsf) .
ln -sf $(build-classpath poi) jakarta-poi.jar
ln -sf $(build-classpath rife-continuations) .
popd
pushd lib/optional
ln -sf $(build-classpath bsh) .
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-digester) .
ln -sf $(build-classpath freemarker) .
ln -sf $(build-classpath itext) .
ln -sf $(build-classpath poi) jakarta-poi.jar
ln -sf $(build-classpath jasperreports) .
ln -sf $(build-classpath jcommon) .
ln -sf $(build-classpath jfreechart) .
ln -sf $(build-classpath log4j) .
#BUILD/webwork/lib/optional/log4j-1.2.8.jar.no
popd
#pushd lib/resin
#BUILD/webwork/lib/resin/jmx.jar.no
#BUILD/webwork/lib/resin/jsdk23.jar.no
#BUILD/webwork/lib/resin/jta_101.jar.no
#BUILD/webwork/lib/resin/resin.jar.no
#popd


ant -Dbuild.sysclasspath=first dist

%install

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p build/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p build/webflow-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/webflow-%{version}.jar
cp -p build/%{name}-config-browser.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-config-browser-%{version}.jar
cp -p build/%{name}-migration.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-migration-%{version}.jar
cp -p build/%{name}-multipart-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-multipart-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp build/webwork.tld $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp build/%{name}-example.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf build/dist/docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/LICENSE.txt

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/webflow*.jar
%{_javadir}/%{name}-config-browser*.jar
%{_javadir}/%{name}-migration*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%{_libdir}/gcj/%{name}/webflow-%{version}.jar.*
%endif

%files multipart
%{_javadir}/%{name}-multipart*.jar

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%changelog
* Sat Jan 26 2008 Igor Vlasenko <viy@altlinux.ru> 0:2.1.7-alt1_2jpp1.7
- converted from JPackage by jppimport script

